// @charset utf-8;
/**
*@version 2.3
*@AKAI Anna stable for Nokia s40 6-th edition
*@vendor vl@volk
*@idea by limil
*/

import javax.microedition.lcdui.*;

public class AKAICanvas extends Canvas {
 public AKAISound snd, bg;
 public int GW, GH, KC, currentNote, currentBg = 0, FSizeX = 8, FSizeY = 8, lineToX = 3, lineToY = 4, oldCode = 0;
 public String[]
/* Этот метод предназначен для воспроизведения мелодий с разными миме-типами. На данный момент не используется.
 mime = new String[]{ "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav", "audio/X-wav" },
*/
 name = new String[]{ "4.wav", "5.wav", "6.wav", "7.wav", "8.wav", "9.wav", "10.wav", "11.wav", "12.wav" },
 bgname = new String[]{ "1.mid", "2.mid", "3.mid", "4.mid", "5.mid" },
 InkFnt = new String[]{ "11777117Z", "24616724Z", "64212764Z", "162716252536273641366441Z" };

 public AKAICanvas() {
  super();
  setFullScreenMode( true );
  GW = getWidth();
  GH = getHeight();
  snd = new AKAISound( name, "audio/X-wav", name.length );
  bg = new AKAISound( bgname, "audio/midi", bgname.length );
  currentNote = -1;
  repaint();
 }

 public void paint( Graphics g ) {

  g.setColor( 0x000000 );
  g.fillRect( 0, 0, GW, GH );

  g.setColor( 0x00ff00 );
  for( int i = 1; i < lineToY; i++ ) {
   g.drawLine( 0, i * getHeight() / lineToY, getWidth(), i * getHeight() / lineToY );
   }
  for( int i = 1; i < lineToX; i++ ) {
   g.drawLine( i * getWidth() / lineToX, 0, i * getWidth() / lineToX, getHeight() );
  }
  g.setColor( 0xff0000 );
  for( int i = 0; i < lineToY-1; i++ )
  for(int j = 0; j < lineToX; j++ ) {
   if( currentNote == j+i*lineToX && currentNote >= 0 ) {
    printInkChar( g, 3, j*getWidth()/lineToX, i*getHeight()/lineToY,getWidth()/lineToX,getHeight()/lineToY);
   }
  }

  printInkChar( g, 1, 0 * getWidth() / lineToX, 3 * getHeight() / lineToY, getWidth() / lineToX, getHeight() / lineToY );
  printInkChar( g, 0, 1 * getWidth() / lineToX, 3 * getHeight() / lineToY, getWidth() / lineToX, getHeight() / lineToY );
  printInkChar( g, 2, 2 * getWidth() / lineToX, 3 * getHeight() / lineToY, getWidth() / lineToX, getHeight() / lineToY );
 }

 public void keyPressed( int keyCode ) {
  KC = keyCode;
  switch( KC ) {
   case 49:
    doAction( 0 );
     break;
   case 50:
    doAction( 1 );
     break;
   case 51:
    doAction( 2 );
     break;
   case 52:
    doAction( 3 );
     break;
   case 53:
    doAction( 4 );
     break;
   case 54:
    doAction( 5 );
     break;
   case 55:
    doAction( 6 );
     break;
   case 56:
    doAction( 7 );
     break;
   case 57:
    doAction( 8 );
     break;
   case 48:
    doAction( 10 );
     break;
   case 42:
    doAction( 9 );
     break;
   case 35:
    doAction( 11 );
     break;
   case -5:
   case -6:
   case -7:
    AKAIMidlet.link.destroyApp( true );
     break;
  }
 }


 public void pointerPressed( int x, int y ) {
  doAction( x / ( getWidth() / lineToX ) + lineToX * ( y / ( getHeight() / lineToY ) ));
 }

 public void keyReleased( int keyCode ) {
  currentNote = -1;
  repaint();
 }

 public void pointerReleased( int x, int y ) {
  currentNote = -1;
  repaint();
 }
 
 public void doAction( int code ) {
  if( code >= 0 && code < 9 ) {
   currentNote = code;
  snd.momentalStopSound( oldCode );
  snd.momentalStopSound( code );
  snd.playSounds( code, -1, false );
  oldCode = code;
   repaint();
  }
  switch( code ) {
   case 9:
    bg.momentalStopSound( currentBg );
    currentBg--;
    if ( currentBg < 0 ) currentBg = 4;
    bg.playSounds( currentBg, 10, true );
     break;
   case 10:
    AKAIMidlet.link.destroyApp( true );
     break;
   case 11:
    bg.momentalStopSound( currentBg );
    currentBg++;
    if ( currentBg > 4 ) currentBg = 0;
    bg.playSounds( currentBg, 10, true );
     break;
  }
 }

 private void printInkChar( Graphics gg, int cchar, int cdx, int cdy, int mdx, int mdy ) {
  int i=0;
  while( InkFnt[ cchar ].charAt( i ) != 'Z' ) {
   gg.drawLine( cdx + ( ( ( ( int ) InkFnt[ cchar ].charAt( i ) ) - 48 ) * mdx / FSizeX ), cdy + ( ( ( ( int ) InkFnt[ cchar ].charAt( i + 1 ) ) - 48 ) * mdy / FSizeY ), cdx + ( ( ( ( int ) InkFnt[ cchar ].charAt( i + 2 ) ) - 48 ) * mdx / FSizeX ), cdy + ( ( ( ( int ) InkFnt[ cchar ].charAt( i + 3 ) ) - 48 ) * mdy / FSizeY ) );
   i = i + 4;
  }
 }
}
